; #################################################################################### 
; ####################################################################################

GetIdtbase MACRO reg
    ; Base idt courant
    sub esp, 8
        sidt qword ptr [esp]
        mov reg, dword ptr [esp+2]
    add esp, 8                     
ENDM

; #################################################################################### 
; ####################################################################################

GetGdtbase MACRO reg
    ; Base gdt courant
    sub esp, 8
        sgdt qword ptr [esp]
        mov reg, dword ptr [esp+2]
    add esp, 8                     
ENDM

; #################################################################################### 
; ####################################################################################

GetGdtDirectoryBaseBySelector MACRO 
    pushad                      
        ; Base gdt courant
        GetGdtbase eax                    
        
        ; Selecteur de segment
        mov ebx, dword ptr [esp+_pushad+4+(0*4)]
        and ebx, (NOT 11b)  
        
        push eax
        push ebx
        call get_gdt_directory_base 
          
    mov dword ptr [esp+_eax], eax    
    popad
    ret 4
ENDM

; ------------------------------------------------------------------------------------ 
get_gdt_directory_base_by_selector :
    GetGdtDirectoryBaseBySelector  
; ------------------------------------------------------------------------------------ 

; #################################################################################### 
; ####################################################################################

GetGdtDirectoryBase MACRO 

local sortie, erreur

    pushad                                     
        ; GDT base
        mov ecx, dword ptr [esp+_pushad+4+(1*4)]                    
    
        push ecx
        call is_virtual_address_valid  
        or eax,eax
        je erreur       
        
        ; Selecteur de segment
        mov ebx, dword ptr [esp+_pushad+4+(0*4)]
        and ebx, (NOT 11b)  
        
        lea edi, dword ptr [ecx+ebx+4] 
        push edi
        call is_virtual_address_valid  
        or eax,eax
        je erreur  
        
        sub edi, 4        
        push edi
        call is_virtual_address_valid  
        or eax,eax
        je erreur          
              
        movzx eax, word ptr [edi+2]
        mov ebx, dword ptr [edi+4] 
        mov ecx, ebx
        shl ebx, 10h
        and ebx, 000FF0000h
        and ecx, 0FF000000h
        or eax, ebx
        or eax, ecx         
sortie :
    mov dword ptr [esp+_eax], eax
    popad
    ret (2*4)
    
erreur :
   xor eax,eax
   jmp sortie
ENDM

; ------------------------------------------------------------------------------------ 
get_gdt_directory_base :
    GetGdtDirectoryBase  
; ------------------------------------------------------------------------------------ 
